
#pragma hdrstop
#include <condefs.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <io.h>
#pragma argsused

// Prototype des fonctions de lecture et d'criture des images BMP

char Read_BMP_320x200 (char *filename, unsigned char *pImage);
char Write_BMP_320x200 (char *filename,unsigned char *pImage);

// Programme principal

void main(int argc, char* argv[])
{
        unsigned char Im[200][320][3];                          // Tableau contenant l'image
        int x,y;                                                // Variable pour parcourir l'image

        if (Read_BMP_320x200("logoIUT.bmp",&Im[0][0][0])!=0)    // Lecture de l'image
        {
                printf ("Erreur lors de l'ouverture");
                exit (0);
        }

        for (x=0;x<320;x++)                                     // Modification de l'image
                for (y=0;y<200;y++)
         		       Im[y][x][0]=255;

        if (Write_BMP_320x200("logoIUT2.bmp",&Im[0][0][0])!=0)  // Sauvegarde de l'image
        {
                printf ("Erreur lors de l'criture");
                exit (0);
        }
        
        printf ("Conversion russie");
        getch();
}

// Cette fonction permet de charger une image BMP 320x200

char Read_BMP_320x200 (char *pFilename, unsigned char *pImage)
{
        FILE *file = fopen(pFilename,"rb");                             // Ouverture du fichier
        if (file==NULL) return (-1);                                    // Ouverture russie ?
        if (fseek (file,54,0)!=0) return (-2);                          // Se place au dbut de l'image
        if (fread (pImage,3,320*200,file)!=320*200) return (-3);        // Lit l'image
        fclose (file);                                                  // Ferme de fichier
        return (0);                                                     // Pas d'erreur
}

// Cette fonction permet d'enregistrer une image BMP 320x200 dans le fichier pFilename

char Write_BMP_320x200 (char *pFilename,unsigned char *pImage)
{
        char Header[54]={66,77,54,-18,2,0,0,0,                          // Cration de l'entte
                        0,0,54,0,0,0,40,0,                              // 320 x 200
                        0,0,64,1,0,0,-56,0,                             // 16M de couleurs
                        0,0,1,0,24,0,0,0,                               // ...
                        0,0,0,-18,2,0,0,0,
                        0,0,0,0,0,0,0,0,
                        0,0,0,0,0,0};

        FILE *file = fopen(pFilename,"rb+");                            // Ouverture du fichier
        if (file==NULL) return (-1);                                    // Ouverture russie ?
        if (fwrite (Header,1,54,file)!=54) return (-2);                 // Ecrit l'entte
        if (fwrite (pImage,3,64000,file)!=320*200) return (-3);         // Ecrit l'image
        fclose (file);                                                  // Fermeture du fichier
        return (0);                                                     // Pas d'erreur
}